package compute

import (
	"context"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// MassRebootRequest struct to reboot several computes
type MassRebootRequest struct {
	// IDs of compute instances to reboot
	// Required: true
	ComputeIDs []uint64 `url:"computeIds" json:"computeIds" validate:"min=1"`
}

type wrapperMassRebootRequest struct {
	MassRebootRequest

	AsyncMode bool `url:"asyncMode"`
}

// MassReboot starts jobs to reboot several computes
func (c Compute) MassReboot(ctx context.Context, req MassRebootRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperMassRebootRequest{
		MassRebootRequest: req,
		AsyncMode:         false,
	}

	url := "/cloudbroker/compute/massReboot"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return false, err
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}

// MassRebootAsync starts jobs to reboot several computes with AsyncMode
func (c Compute) MassRebootAsync(ctx context.Context, req MassRebootRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperMassRebootRequest{
		MassRebootRequest: req,
		AsyncMode:         true,
	}

	url := "/cloudbroker/compute/massReboot"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return "", err
	}

	return string(res), nil
}
